import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
import _extends from "@babel/runtime/helpers/extends";
var _excluded = ["title", "children", "btnType", "btnText", "disabled", "width", "filterItems", "getTableData", "columns", "rowSelection", "pagination", "rowKey", "confirmText", "itemWidth", "initialValues", "buttons", "onSubmit", "onClose", "formatPreviewItemValue"];
import React, { useMemo, useState, useEffect, useRef } from 'react';
import styles from "./index.module.less";
import { Drawer, Tooltip } from 'antd';
import { CloseCircleFilled, LeftOutlined, RightOutlined, DownOutlined, UpOutlined } from '@ant-design/icons';
import { unionBy, xorBy } from 'lodash';
import YwFilter from "../YwFilter";
import YwTable from "../YwTable";
import YwButton from "../YwButton";
import { isObject } from "../../utils/index";

var PreviewList = function PreviewList(_ref) {
  var dataSource = _ref.dataSource,
      _ref$pageSize = _ref.pageSize,
      pageSize = _ref$pageSize === void 0 ? 10 : _ref$pageSize,
      deleteItem = _ref.deleteItem,
      rowKey = _ref.rowKey,
      formatPreviewItemValue = _ref.formatPreviewItemValue;
  var total = useMemo(function () {
    return dataSource.length || 0;
  }, [dataSource]); // 倒序显示

  var perviewData = useMemo(function () {
    return dataSource || [];
  }, [dataSource]);
  useEffect(function () {
    setIsShow(total > 0);
    return function () {
      setPageIndex(1);
      setIsShow(false);
    };
  }, [total]);

  var _useState = useState(1),
      pageIndex = _useState[0],
      setPageIndex = _useState[1];

  var _useState2 = useState(false),
      isShow = _useState2[0],
      setIsShow = _useState2[1];

  var startIdx = useMemo(function () {
    return pageIndex === 1 ? 0 : pageSize * (pageIndex - 1);
  }, [pageIndex, total]);
  var endIdx = useMemo(function () {
    return pageIndex * pageSize >= total ? total : pageSize * pageIndex;
  }, [pageIndex, total]);
  return /*#__PURE__*/React.createElement("div", {
    className: styles['preview-container'] + " " + (!isShow ? styles['preview-container-close'] : '')
  }, /*#__PURE__*/React.createElement("div", {
    className: styles['preview-container-bar']
  }, /*#__PURE__*/React.createElement("div", {
    className: styles['preview-container-bar-left']
  }, /*#__PURE__*/React.createElement("span", {
    style: {
      marginRight: '12px'
    }
  }, "\u5DF2\u9009\u62E9 ", total, " \u6761"), isShow ? /*#__PURE__*/React.createElement(DownOutlined, {
    style: {
      fontSize: 12,
      color: '#a6a6a6'
    },
    onClick: function onClick() {
      setIsShow(false);
    }
  }) : /*#__PURE__*/React.createElement(UpOutlined, {
    style: {
      fontSize: 12,
      color: '#a6a6a6'
    },
    onClick: function onClick() {
      setIsShow(true);
    }
  })), /*#__PURE__*/React.createElement("div", {
    className: styles['preview-container-bar-right'] + " " + (pageIndex * pageSize >= total ? styles.disabled : '')
  }, /*#__PURE__*/React.createElement("span", {
    className: styles['prev'] + " " + (pageIndex === 1 ? styles.disabled : ''),
    onClick: function onClick() {
      if (pageIndex > 1) {
        setPageIndex(pageIndex - 1);
      }
    }
  }, /*#__PURE__*/React.createElement(LeftOutlined, null)), /*#__PURE__*/React.createElement("span", {
    onClick: function onClick() {
      if (pageIndex * pageSize < total) {
        setPageIndex(pageIndex + 1);
      }
    },
    className: styles['next'] + " " + (pageIndex * pageSize >= total || total === 0 ? styles.disabled : '')
  }, /*#__PURE__*/React.createElement(RightOutlined, null)))), !!perviewData.length && /*#__PURE__*/React.createElement("div", {
    className: styles['preview-list']
  }, perviewData.slice(startIdx, endIdx).map(function (item, index) {
    var data = formatPreviewItemValue(item);
    var content = /*#__PURE__*/React.createElement("div", {
      className: styles['preview-item'],
      key: item[rowKey],
      onClick: function onClick() {
        deleteItem(item[rowKey], item);
      }
    }, /*#__PURE__*/React.createElement("span", {
      className: styles['order']
    }, index + 1 + pageSize * (pageIndex - 1)), /*#__PURE__*/React.createElement("img", {
      src: data.imgUrl,
      alt: ""
    }), /*#__PURE__*/React.createElement(CloseCircleFilled, {
      className: styles['close']
    }));
    return data.tooltip ? /*#__PURE__*/React.createElement(Tooltip, _extends({
      placement: "topLeft"
    }, data.tooltip), content) : content;
  })));
};

var YwDrawerSelector = function YwDrawerSelector(_ref2) {
  var title = _ref2.title,
      children = _ref2.children,
      btnType = _ref2.btnType,
      btnText = _ref2.btnText,
      disabled = _ref2.disabled,
      width = _ref2.width,
      filterItems = _ref2.filterItems,
      getTableData = _ref2.getTableData,
      columns = _ref2.columns,
      rowSelection = _ref2.rowSelection,
      pagination = _ref2.pagination,
      rowKey = _ref2.rowKey,
      confirmText = _ref2.confirmText,
      itemWidth = _ref2.itemWidth,
      initialValues = _ref2.initialValues,
      buttons = _ref2.buttons,
      onSubmit = _ref2.onSubmit,
      _onClose = _ref2.onClose,
      formatPreviewItemValue = _ref2.formatPreviewItemValue,
      others = _objectWithoutPropertiesLoose(_ref2, _excluded);

  var _useState3 = useState(others.visible || false),
      visible = _useState3[0],
      setVisible = _useState3[1];

  var _useState4 = useState(false),
      confirmLoading = _useState4[0],
      setConfirmLoading = _useState4[1];

  var formRef = useRef(null);

  var _useState5 = useState([]),
      selectedData = _useState5[0],
      setSelectedData = _useState5[1];

  var _useState6 = useState([]),
      selectedRowKeys = _useState6[0],
      setSelectedRowKeys = _useState6[1];

  var _useState7 = useState(initialValues),
      filterProps = _useState7[0],
      setFilterProps = _useState7[1]; //   const onClose = () => {
  //     // setVisible(false);
  //   };


  var isControl = useMemo(function () {
    return others.visible !== undefined;
  }, [others.visible]);

  var handleInit = function handleInit() {
    setFilterProps(initialValues || {});
    setConfirmLoading(false);
    setSelectedData([]);
    setSelectedRowKeys([]);
    formRef.current && formRef.current.reset();
  };

  useEffect(function () {
    setVisible(others.visible); // others.visible && handleInit();
  }, [others.visible]);
  useEffect(function () {
    if (visible) {
      handleInit();
    }
  }, [visible]);

  var _rowSelection = _extends({}, rowSelection, {
    selectedRowKeys: selectedRowKeys,
    hideSelectTotal: true,
    // onChange: (keys, data, info) => {
    //   setSelectedData(unionBy(selectedData, data, rowKey));
    //   setSelectedRowKeys(union(selectedRowKeys, keys));
    // },
    onSelectAll: function onSelectAll(selected, _, changeRows) {
      if (selected) {
        var data = unionBy(changeRows, selectedData, rowKey) || [];
        setSelectedData(data);
        setSelectedRowKeys(data.map(function (v) {
          return v[rowKey];
        }));
      } else {
        var _data = xorBy(selectedData, changeRows, rowKey);

        setSelectedData(_data);
        setSelectedRowKeys(_data.map(function (v) {
          return v[rowKey];
        }));
      }
    },
    onSelect: function onSelect(record, selected) {
      if (selected) {
        var data = unionBy([record], selectedData, rowKey);
        setSelectedData(data);
        setSelectedRowKeys(data.map(function (v) {
          return v[rowKey];
        }));
      } else {
        setSelectedData(selectedData.filter(function (v) {
          return v[rowKey] !== record[rowKey];
        }));
        setSelectedRowKeys(selectedRowKeys.filter(function (v) {
          return v !== record[rowKey];
        }));
      }
    }
  });

  var renderFooter = function renderFooter() {
    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(YwButton, {
      btnText: confirmText,
      btnType: "primary",
      loading: confirmLoading,
      onClick: function onClick() {
        setConfirmLoading(true);
        onSubmit(selectedRowKeys, selectedData).then(function () {
          !isControl ? setVisible(false) : _onClose();
        })["finally"](function () {
          setConfirmLoading(false);
        });
      }
    }), /*#__PURE__*/React.createElement(YwButton, {
      btnText: "\u5173\u95ED",
      style: {
        marginLeft: '12px'
      },
      onClick: function onClick() {
        !isControl ? setVisible(false) : _onClose();
      }
    }));
  };

  return /*#__PURE__*/React.createElement(React.Fragment, null, !isControl && /*#__PURE__*/React.createElement("div", {
    onClick: function onClick() {
      setVisible(true);
    },
    style: {
      display: 'inline-block'
    }
  }, children || /*#__PURE__*/React.createElement(YwButton, {
    btnText: btnText,
    btnType: btnType,
    disabled: disabled
  })), /*#__PURE__*/React.createElement(Drawer, {
    visible: visible,
    width: width,
    className: styles['yw-drawer-selector'],
    title: title,
    bodyStyle: {
      padding: '20px'
    },
    maskClosable: false,
    onClose: function onClose() {
      !isControl ? setVisible(false) : _onClose();
    },
    contentWrapperStyle: {
      display: visible ? 'block' : 'none'
    },
    keyboard: false,
    destroyOnClose: true,
    footerStyle: {
      display: 'flex',
      justifyContent: 'flex-end',
      alignItems: 'center'
    },
    footer: renderFooter()
  }, /*#__PURE__*/React.createElement(React.Fragment, null, filterItems && /*#__PURE__*/React.createElement(YwFilter, {
    itemWidth: itemWidth,
    items: filterItems,
    columnGap: 15,
    initialValues: initialValues,
    onSubmit: function onSubmit(data) {
      setFilterProps(_extends({}, data));
    },
    onCreate: function onCreate(_form) {
      formRef.current = _form;
    }
  }), /*#__PURE__*/React.createElement("div", {
    className: styles['yw-drawer-selector-table-container']
  }, /*#__PURE__*/React.createElement(YwTable, {
    filterProps: filterProps,
    getTableData: getTableData,
    columns: columns,
    buttons: buttons,
    rowSelection: _rowSelection,
    pagination: isObject(pagination) ? _extends({
      size: 'small'
    }, pagination) : pagination,
    rowKey: rowKey
  })), /*#__PURE__*/React.createElement(PreviewList, {
    dataSource: selectedData,
    pageSize: 10,
    rowKey: rowKey,
    formatPreviewItemValue: formatPreviewItemValue,
    deleteItem: function deleteItem(key, data) {
      setSelectedData(selectedData.filter(function (v) {
        return v[rowKey] !== data[rowKey];
      }));
      setSelectedRowKeys(selectedRowKeys.filter(function (v) {
        return v !== key;
      }));
    }
  }))));
};

YwDrawerSelector.defaultProps = {
  width: '833px',
  pagination: {},
  rowSelection: {},
  rowKey: 'id',
  confirmText: '确认' //   itemWidth: 216,

};
export default YwDrawerSelector;