import _extends from "@babel/runtime/helpers/extends";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
var _excluded = ["getDataSource", "getOrgList", "visible"],
    _excluded2 = ["value"];
import _regeneratorRuntime from "@babel/runtime/regenerator";
import React, { useEffect, useState, useMemo } from 'react';
import styles from "./index.module.less";
import { Tag, Checkbox, Col, Row, Breadcrumb, Spin } from 'antd';
import { get, last, unionBy, xorBy } from 'lodash';
import { LeftOutlined, RightOutlined } from '@ant-design/icons';
import ModalSelector from "../common/modalSelector";
import commonStyles from "../common/index.module.less";
import { formatOptionsList } from "../../utils/index"; //

var renderUser = function renderUser(userItem) {
  return /*#__PURE__*/React.createElement("div", {
    className: styles['emp-item']
  }, /*#__PURE__*/React.createElement("div", {
    className: styles['avatar']
  }, /*#__PURE__*/React.createElement("img", {
    src: userItem.headIconUrl,
    alt: ""
  })), /*#__PURE__*/React.createElement("div", {
    className: styles['item-info']
  }, /*#__PURE__*/React.createElement("span", {
    className: styles['item-info-name']
  }, userItem.userName, " (", userItem.realName, ")"), /*#__PURE__*/React.createElement("span", null, userItem.position), /*#__PURE__*/React.createElement("span", {
    className: styles['row-1']
  }, userItem.orgPathDesc)));
};

var YwEmpSelector = function YwEmpSelector(_ref) {
  var getDataSource = _ref.getDataSource,
      getOrgList = _ref.getOrgList,
      visible = _ref.visible,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  var defaultValue = useMemo(function () {
    return formatOptionsList(props.defaultValue || [], {
      label: 'userId',
      value: 'userName'
    }) || [];
  }, [props.defaultValue]);

  var _useState = useState(defaultValue.map(function (v) {
    return v.value;
  })),
      checkedList = _useState[0],
      setCheckedList = _useState[1];

  var _useState2 = useState(false),
      indeterminate = _useState2[0],
      setIndeterminate = _useState2[1];

  var _useState3 = useState(false),
      checkAll = _useState3[0],
      setCheckAll = _useState3[1];

  var _useState4 = useState([]),
      orgList = _useState4[0],
      setOrgList = _useState4[1];

  var _useState5 = useState(defaultValue),
      selectValue = _useState5[0],
      setSelectValue = _useState5[1];

  var _useState6 = useState([]),
      userList = _useState6[0],
      setUserList = _useState6[1];

  var _useState7 = useState(false),
      loading = _useState7[0],
      setLoading = _useState7[1];

  var _useState8 = useState(['[0]']),
      orgPathList = _useState8[0],
      setOrgPathList = _useState8[1];

  var currentOrg = useMemo(function () {
    return get(orgList, last(orgPathList));
  }, [orgPathList, orgList]);
  var orgPath = useMemo(function () {
    return last(orgPathList);
  }, [orgPathList]);

  var _onChange = function onChange(e, record) {
    if (e.target.checked) {
      var _selectData = unionBy([record], selectValue, 'value');

      setCheckedList([].concat(checkedList, [e.target.value]));
      setSelectValue(_selectData);
    } else {
      setCheckedList(checkedList.filter(function (v) {
        return v !== record.value;
      }));
      setSelectValue(xorBy(selectValue, [record], 'value'));
    }
  };

  useEffect(function () {
    var isAll = !!userList.length && userList.every(function (item) {
      return checkedList.includes(item.value);
    });
    setIndeterminate(userList.some(function (item) {
      return checkedList.includes(item.value);
    }) && !isAll);
    setCheckAll(isAll);
  }, [userList, checkedList]);

  var onCheckAllChange = function onCheckAllChange(e) {
    setCheckedList(e.target.checked ? userList.map(function (v) {
      return v.value;
    }) : []);

    if (e.target.checked) {
      var _selectData = unionBy(userList, selectValue, 'value');

      setSelectValue(_selectData);
    } else {
      setSelectValue(xorBy(selectValue, userList, 'value'));
    }
  };

  useEffect( /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
    var orgList, res;
    return _regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return getOrgList();

          case 2:
            orgList = _context.sent;
            res = formatOptionsList(orgList, {
              label: 'orgName',
              value: 'orgId',
              children: 'subOrgList'
            });
            setOrgList([{
              value: '0',
              label: '杭州遥望科技有限公司',
              children: res
            }]);

          case 5:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  })), []);

  var getDeptUser = /*#__PURE__*/function () {
    var _ref3 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2(org) {
      var res;
      return _regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              setLoading(true);
              _context2.next = 3;
              return getDataSource({
                orgId: org.value
              });

            case 3:
              res = _context2.sent;
              setUserList(formatOptionsList(res, {
                label: 'userId',
                value: 'userName'
              }));
              setLoading(false);

            case 6:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));

    return function getDeptUser(_x) {
      return _ref3.apply(this, arguments);
    };
  }();

  var onExpandOrg = function onExpandOrg(org, i) {
    setOrgPathList([].concat(orgPathList, [orgPathList[orgPathList.length - 1] + ".children[" + i + "]"]));
  };

  var renderDept = function renderDept() {
    var _currentOrg$children, _currentOrg$children2;

    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
      className: commonStyles['title'],
      onClick: function onClick() {
        setOrgPathList(['0']);
        setUserList([]);
      }
    }, /*#__PURE__*/React.createElement(LeftOutlined, {
      style: {
        fontSize: '12px',
        color: '#D8D8D8',
        marginRight: '12px'
      }
    }), /*#__PURE__*/React.createElement("span", null, "\u676D\u5DDE\u9065\u671B\u79D1\u6280\u6709\u9650\u516C\u53F8")), (orgPathList === null || orgPathList === void 0 ? void 0 : orgPathList.length) > 1 && /*#__PURE__*/React.createElement("div", {
      className: commonStyles['dept-list']
    }, /*#__PURE__*/React.createElement(Breadcrumb, null, orgPathList.map(function (v, i) {
      if (i === 0) return null;
      return /*#__PURE__*/React.createElement(Breadcrumb.Item, {
        className: commonStyles['dept-list-path-item'],
        onClick: function onClick() {
          setOrgPathList([].concat(orgPathList.slice(0, i + 1)));
          setUserList([]); // onExpandOrg(v, i);
        }
      }, get(orgList, v + ".label"));
    }))), !!(currentOrg !== null && currentOrg !== void 0 && (_currentOrg$children = currentOrg.children) !== null && _currentOrg$children !== void 0 && _currentOrg$children.length) && !userList.length && /*#__PURE__*/React.createElement(React.Fragment, null, currentOrg === null || currentOrg === void 0 ? void 0 : (_currentOrg$children2 = currentOrg.children) === null || _currentOrg$children2 === void 0 ? void 0 : _currentOrg$children2.map(function (v, i) {
      return /*#__PURE__*/React.createElement(Row, {
        align: "middle",
        className: commonStyles['item-row']
      }, /*#__PURE__*/React.createElement(Col, {
        span: 2,
        onClick: function onClick() {
          onExpandOrg(v, i);
        }
      }, v.children && /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("img", {
        src: "https://yw-fed-static.oss-cn-hangzhou.aliyuncs.com/ywDesign/img/expand_icon.png"
      }))), /*#__PURE__*/React.createElement(Col, {
        span: 20,
        onClick: function onClick() {
          onExpandOrg(v, i);
          getDeptUser(v);
        }
      }, /*#__PURE__*/React.createElement("span", null, " ", v.label)), /*#__PURE__*/React.createElement(Col, {
        span: 2 // className={commonStyles['item-row-right']}
        ,
        onClick: function onClick() {
          onExpandOrg(v, i);
          getDeptUser(v);
        }
      }, !v.children && /*#__PURE__*/React.createElement(RightOutlined, {
        style: {
          fontSize: '12px',
          color: '#D8D8D8',
          marginRight: '12px'
        }
      })));
    })));
  };

  return /*#__PURE__*/React.createElement("div", {
    className: styles['yw-emp-selector']
  }, /*#__PURE__*/React.createElement(ModalSelector, _extends({}, props, {
    visible: visible,
    labelInValue: true,
    tagRender: function tagRender(_ref4) {
      var value = _ref4.value,
          props = _objectWithoutPropertiesLoose(_ref4, _excluded2);

      return /*#__PURE__*/React.createElement(Tag, props, value);
    },
    value: selectValue,
    onChange: function onChange(value, data) {
      if (data === void 0) {
        data = [];
      }

      var _value = value.map(function (v) {
        var _data$find;

        var userId = (_data$find = data.find(function (item) {
          return item.userName === v.value;
        })) === null || _data$find === void 0 ? void 0 : _data$find.userId;
        return _extends({}, v, {
          label: userId
        });
      });

      setSelectValue(_value);
    },
    onOk: function onOk(data) {
      props.onOk(data.map(function (v) {
        var _ref5;

        return _ref5 = {}, _ref5[props.fieldNames.label] = v.userName, _ref5[props.fieldNames.value] = v.label, _ref5;
      }));
    },
    fieldNames: {
      label: 'label',
      value: 'userName'
    },
    fetchOptions: /*#__PURE__*/function () {
      var _ref6 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee4(value) {
        return _regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                return _context4.abrupt("return", new Promise( /*#__PURE__*/function () {
                  var _ref7 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee3(resolve) {
                    var data, userData;
                    return _regeneratorRuntime.wrap(function _callee3$(_context3) {
                      while (1) {
                        switch (_context3.prev = _context3.next) {
                          case 0:
                            _context3.next = 2;
                            return getDataSource(value);

                          case 2:
                            _context3.t0 = _context3.sent;

                            if (_context3.t0) {
                              _context3.next = 5;
                              break;
                            }

                            _context3.t0 = [];

                          case 5:
                            data = _context3.t0;
                            userData = data.map(function (user) {
                              return _extends({}, user, {
                                label: renderUser(user),
                                key: user.userId
                              });
                            });
                            resolve(userData);

                          case 8:
                          case "end":
                            return _context3.stop();
                        }
                      }
                    }, _callee3);
                  }));

                  return function (_x3) {
                    return _ref7.apply(this, arguments);
                  };
                }()));

              case 1:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4);
      }));

      return function (_x2) {
        return _ref6.apply(this, arguments);
      };
    }()
  }), renderDept(), /*#__PURE__*/React.createElement(Spin, {
    spinning: loading
  }, !!userList.length && /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Row, {
    style: {
      marginBottom: '10px'
    }
  }, /*#__PURE__*/React.createElement(Col, null, /*#__PURE__*/React.createElement(Checkbox, {
    indeterminate: indeterminate,
    onChange: onCheckAllChange,
    checked: checkAll
  }, "\u5168\u9009"))), /*#__PURE__*/React.createElement(Checkbox.Group, {
    style: {
      width: '100%'
    },
    value: checkedList
  }, userList.map(function (v) {
    return /*#__PURE__*/React.createElement(Row, {
      align: "middle",
      className: styles['emp-item']
    }, /*#__PURE__*/React.createElement(Col, null, /*#__PURE__*/React.createElement(Checkbox, {
      value: v.value,
      onChange: function onChange(e) {
        _onChange(e, v);
      }
    })), /*#__PURE__*/React.createElement(Col, {
      className: styles['avatar']
    }, /*#__PURE__*/React.createElement("img", {
      src: v.headIconUrl
    })), /*#__PURE__*/React.createElement(Col, {
      className: styles['item-info']
    }, /*#__PURE__*/React.createElement(Row, null, /*#__PURE__*/React.createElement(Col, {
      className: styles['item-info-name']
    }, v.userName)), /*#__PURE__*/React.createElement(Row, null, /*#__PURE__*/React.createElement(Col, {
      className: styles['row-1']
    }, v.position))));
  }))))));
};

YwEmpSelector.defaultProps = {
  title: '请选择联系人',
  fieldNames: {
    label: 'userName',
    value: 'userId'
  }
};
export default YwEmpSelector;