import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
import _extends from "@babel/runtime/helpers/extends";
var _excluded = ["sortable", "layoutProps", "hasAdd", "maxRow", "minRow", "arrayConfig", "name", "editable"];
import React from 'react';
import { FormItem, Input, Select, NumberPicker, Editable, FormLayout, Radio, ArrayItems, Space } from '@formily/antd';
import { FormProvider, createSchemaField, useParentForm, observer, useFieldSchema } from '@formily/react';
var SchemaField = createSchemaField({
  components: {
    FormItem: FormItem,
    Editable: Editable,
    Input: Input,
    FormLayout: FormLayout,
    NumberPicker: NumberPicker,
    Select: Select,
    RadioGroup: Radio.Group,
    Space: Space,
    ArrayItems: ArrayItems
  }
});

var getArrayItemsSchema = function getArrayItemsSchema(_ref) {
  var _properties;

  var sortable = _ref.sortable,
      name = _ref.name,
      arrayConfig = _ref.arrayConfig,
      editable = _ref.editable,
      arrSchema = _ref.arrSchema,
      maxRow = _ref.maxRow,
      minRow = _ref.minRow;
  var records = {};
  arrayConfig.forEach(function (item, idx) {
    records[item.name] = _extends({}, item, {
      "default": item.defaultValue,
      'x-disabled': item.disabled,
      'x-decorator': item.editable ? 'Editable' : 'FormItem',
      'x-component': item.component,
      'x-validator': item.rules,
      'x-decorator-props': _extends({}, item.props || {}),
      'x-component-props': _extends({}, item.componentProps, {
        required: true
      })
    });
  });
  return {
    type: 'object',
    properties: (_properties = {}, _properties[name] = _extends({}, arrSchema, {
      title: '',
      'x-component': 'ArrayItems',
      'x-decorator': 'FormItem',
      'x-read-pretty': arrSchema.readOnly,
      maxItems: maxRow,
      minItems: minRow,
      'x-component-props': _extends({}, arrSchema['x-component-props']),
      items: {
        type: 'object',
        // 'x-decorator': 'ArrayItems.Item',
        properties: {
          space: {
            type: 'void',
            'x-component': 'Space',
            'x-component-props': {
              align: 'flex-start'
            },
            properties: _extends({}, records, {
              remove: {
                type: 'void',
                title: '删除',
                'x-component': 'ArrayItems.Remove',
                'x-component-props': {
                  style: {
                    color: '#1890ff'
                  } // align: 'flex-start',

                },
                'x-reactions': {
                  dependencies: [name],
                  fulfill: {
                    schema: {
                      'x-visible': '{{$deps[0]?.length > minRow}}' // 任意层次属性都支持表达式

                    }
                  }
                }
              },
              moveUp: {
                type: 'void',
                'x-visible': sortable,
                'x-component': 'ArrayItems.MoveUp'
              },
              moveDown: {
                type: 'void',
                'x-visible': sortable,
                'x-component': 'ArrayItems.MoveDown'
              }
            })
          }
        }
      },
      properties: {
        addition: {
          type: 'void',
          title: '添加',
          'x-component': 'ArrayItems.Addition',
          'x-component-props': {
            align: 'left',
            type: 'link',
            style: {
              width: 80
            }
          },
          'x-reactions': {
            dependencies: [name],
            fulfill: {
              schema: {
                'x-visible': '{{ hasAdd && $deps[0]?.length < maxRow}}'
              }
            }
          }
        }
      }
    }), _properties)
  };
};

var YArrayItems = function YArrayItems(_ref2) {
  var sortable = _ref2.sortable,
      layoutProps = _ref2.layoutProps,
      _ref2$hasAdd = _ref2.hasAdd,
      hasAdd = _ref2$hasAdd === void 0 ? true : _ref2$hasAdd,
      maxRow = _ref2.maxRow,
      _ref2$minRow = _ref2.minRow,
      minRow = _ref2$minRow === void 0 ? 0 : _ref2$minRow,
      _ref2$arrayConfig = _ref2.arrayConfig,
      arrayConfig = _ref2$arrayConfig === void 0 ? [] : _ref2$arrayConfig,
      name = _ref2.name,
      editable = _ref2.editable,
      props = _objectWithoutPropertiesLoose(_ref2, _excluded);

  var form = useParentForm();
  var arrSchema = useFieldSchema();
  var schema = getArrayItemsSchema({
    sortable: sortable,
    arrayConfig: arrayConfig,
    name: name,
    editable: editable,
    arrSchema: arrSchema,
    maxRow: maxRow,
    minRow: minRow
  });
  return /*#__PURE__*/React.createElement(FormProvider, {
    form: form
  }, /*#__PURE__*/React.createElement(SchemaField, {
    schema: schema,
    scope: {
      maxRow: maxRow,
      hasAdd: hasAdd,
      minRow: minRow,
      sortable: sortable
    }
  }));
};

export default observer(YArrayItems);