import * as React from 'react';
import { Switch, Radio, Checkbox, Cascader, Select, Input, FormItem, NumberPicker } from '@formily/antd';
import { WeekRangePicker, DateRangePicker, MonthRangePicker, DateTimeRangePicker, MonthPicker, WeekPicker, DatePicker, DateTimePicker } from "./YDatePicker";
import { FormProvider, createSchemaField, useField, useFieldSchema, useParentForm } from '@formily/react';
var RadioGroup = Radio.Group;
var CheckboxGroup = Checkbox.Group;
var TextArea = Input.TextArea;
var SchemaField = createSchemaField({
  components: {
    FormItem: FormItem,
    Input: Input,
    Select: Select,
    RadioGroup: RadioGroup,
    TextArea: TextArea,
    Switch: Switch,
    CheckboxGroup: CheckboxGroup,
    NumberPicker: NumberPicker,
    Cascader: Cascader,
    WeekRangePicker: WeekRangePicker,
    DateRangePicker: DateRangePicker,
    MonthRangePicker: MonthRangePicker,
    DateTimeRangePicker: DateTimeRangePicker,
    MonthPicker: MonthPicker,
    WeekPicker: WeekPicker,
    DatePicker: DatePicker,
    DateTimePicker: DateTimePicker
  }
});

var YInputGroup = function YInputGroup(props) {
  var field = useField();
  var form = useParentForm();
  var schema = useFieldSchema();
  return /*#__PURE__*/React.createElement(FormProvider, {
    form: form
  }, field.editable ? /*#__PURE__*/React.createElement(Input.Group, {
    compact: true
  }, /*#__PURE__*/React.createElement(Select, {
    defaultValue: field.initialValue,
    disabled: field.disabled,
    options: field.dataSource,
    onChange: function onChange(v) {
      field.setValue(v);
    }
  }), /*#__PURE__*/React.createElement(SchemaField, {
    schema: schema
  })) : /*#__PURE__*/React.createElement(SchemaField, {
    schema: schema
  }));
};

export default YInputGroup;