import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
var _excluded = ["value", "fieldNames", "getOrgList"];
import React, { useState } from 'react';
import { Select } from 'antd';
import { useField } from '@formily/react';
import YwOrgSelector from "../YwOrgSelector/index";
import { formatOptionsList } from "../../utils/index";

var YOrgSelector = function YOrgSelector(_ref) {
  var value = _ref.value,
      _ref$fieldNames = _ref.fieldNames,
      fieldNames = _ref$fieldNames === void 0 ? {
    label: 'orgName',
    value: 'orgId'
  } : _ref$fieldNames,
      getOrgList = _ref.getOrgList,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  var field = useField();

  var _useState = useState(false),
      visible = _useState[0],
      setVisible = _useState[1];

  var _useState2 = useState(field.initialValue || []),
      orgValue = _useState2[0],
      setOrgValue = _useState2[1];

  var maxItems = props.maxItems;
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Select, {
    onDropdownVisibleChange: function onDropdownVisibleChange(open) {
      open && setVisible(open);
    },
    dropdownStyle: {
      display: 'none'
    },
    labelInValue: true,
    value: formatOptionsList(orgValue, fieldNames),
    dropdownRender: function dropdownRender() {
      return null;
    },
    disabled: field.disabled,
    options: formatOptionsList(orgValue, fieldNames),
    mode: maxItems !== 1 ? 'multiple' : null // defaultValue={field.initialValue}
    // open={false}

  }), /*#__PURE__*/React.createElement(YwOrgSelector, _extends({}, props, {
    getDataSource: getOrgList,
    visible: visible,
    onCancel: function onCancel() {
      setVisible(false);
    },
    defaultValue: field.initialValue,
    onOk: function onOk(data) {
      setOrgValue(data);
      field.setValue(data);
      setVisible(false);
    }
  })));
};

export default YOrgSelector;