import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
var _excluded = ["getDataSource", "visible"];
import React, { useEffect, useState, useMemo } from 'react';
import styles from "./index.module.less";
import commonStyles from "../common/index.module.less";
import { get, set, last, intersectionBy } from 'lodash';
import { Checkbox, Col, Row, Breadcrumb } from 'antd';
import { LeftOutlined } from '@ant-design/icons';
import ModalSelector from "../common/modalSelector";
import { formatOptionsList } from "../../utils/index";

var YwOrgSelector = function YwOrgSelector(_ref) {
  var _currentOrg$children3, _currentOrg$children4;

  var getDataSource = _ref.getDataSource,
      visible = _ref.visible,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  // 部门树结构
  var _useState = useState([]),
      orgTreeList = _useState[0],
      setOrgTreeList = _useState[1];

  var _useState2 = useState([]),
      orgPathList = _useState2[0],
      setOrgPathList = _useState2[1];

  var defaultValue = useMemo(function () {
    return formatOptionsList(props.defaultValue, props.fieldNames);
  }, [props.defaultValue, props.fieldNames]); // select组件回显部门数据
  // const [selectValue, setSelectValue] = useState(defaultValue);
  // 当前节点

  var currentOrg = useMemo(function () {
    return get(orgTreeList, last(orgPathList));
  }, [orgPathList, orgTreeList]); // 当前path

  var orgPath = useMemo(function () {
    return last(orgPathList);
  }, [orgPathList]);

  var onChange = function onChange(list, data) {
    var _currentOrg$children;

    var _currentOrg = _extends({}, currentOrg, {
      checkedList: list,
      checkedData: currentOrg === null || currentOrg === void 0 ? void 0 : currentOrg.children.filter(function (v) {
        return list.includes(v.value);
      }),
      checkAll: list.length === (currentOrg === null || currentOrg === void 0 ? void 0 : currentOrg.children.length),
      checkSome: !!list.length && list.length < (currentOrg === null || currentOrg === void 0 ? void 0 : (_currentOrg$children = currentOrg.children) === null || _currentOrg$children === void 0 ? void 0 : _currentOrg$children.length)
    });

    var _orgTreeList = set(orgTreeList, orgPath, _currentOrg);

    setOrgTreeList([].concat(_orgTreeList));
  };

  var onCheckAllChange = function onCheckAllChange(e) {
    var _currentOrg$children2;

    var _currentOrg = _extends({}, currentOrg, {
      checkedList: e.target.checked ? currentOrg === null || currentOrg === void 0 ? void 0 : (_currentOrg$children2 = currentOrg.children) === null || _currentOrg$children2 === void 0 ? void 0 : _currentOrg$children2.map(function (v) {
        return v.value;
      }) : [],
      checkedData: e.target.checked ? currentOrg === null || currentOrg === void 0 ? void 0 : currentOrg.children : [],
      checkAll: e.target.checked,
      checkSome: false
    });

    var _orgTreeList = set(orgTreeList, orgPath, _currentOrg);

    setOrgTreeList([].concat(_orgTreeList));
  };

  useEffect(function () {}, [orgTreeList]);
  var selectValue = useMemo(function () {
    var _selectValue = [];

    var getItemCheckedData = function getItemCheckedData(dataList) {
      dataList.forEach(function (data) {
        if (data.children) {
          getItemCheckedData(data.children);
        }

        _selectValue.push.apply(_selectValue, data.checkedData || []);
      });
    };

    getItemCheckedData(orgTreeList);
    return _selectValue;
  }, [orgTreeList]);
  useEffect(function () {
    if (visible) {
      getDataSource().then(function (data) {
        var res = formatOptionsList(data, props.fieldNames);
        var _orgTreeList = [{
          value: '0',
          label: '杭州遥望科技有限公司',
          children: res
        }];
        setOrgPathList(['[0]']);

        if (defaultValue !== null && defaultValue !== void 0 && defaultValue.length) {
          setOrgCheckData(defaultValue, _orgTreeList);
        } else {
          setOrgTreeList(_orgTreeList);
        }
      });
    }
  }, [visible]);

  var setOrgCheckData = function setOrgCheckData(nextValue, _orgTreeList) {
    var newOrgTreeList = _orgTreeList || [].concat(orgTreeList);

    var setItemCheckedData = function setItemCheckedData(dataList) {
      dataList.forEach(function (data) {
        var _checkedData = _orgTreeList ? intersectionBy(data.children || [], nextValue, 'value') : intersectionBy(data.checkedData || [], nextValue, 'value') || [];

        data.checkedData = _checkedData;
        data.checkedList = _checkedData.map(function (v) {
          return v.value;
        });

        if (data.children) {
          var _data$children, _data$children2;

          data.checkAll = ((_data$children = data.children) === null || _data$children === void 0 ? void 0 : _data$children.length) === (_checkedData === null || _checkedData === void 0 ? void 0 : _checkedData.length);
          data.checkSome = ((_data$children2 = data.children) === null || _data$children2 === void 0 ? void 0 : _data$children2.length) > (_checkedData === null || _checkedData === void 0 ? void 0 : _checkedData.length) && !!_checkedData.length;
          setItemCheckedData(data.children);
        }
      });
    };

    setItemCheckedData(newOrgTreeList);
    setOrgTreeList([].concat(newOrgTreeList));
  };

  return /*#__PURE__*/React.createElement("div", {
    className: styles['yw-org-selector']
  }, /*#__PURE__*/React.createElement(ModalSelector, _extends({}, props, {
    visible: visible,
    labelInValue: true,
    autoFocus: false,
    showSearch: false,
    value: selectValue,
    onChange: setOrgCheckData
  }), /*#__PURE__*/React.createElement("div", {
    className: commonStyles['title'],
    onClick: function onClick() {
      setOrgPathList(['[0]']);
    }
  }, /*#__PURE__*/React.createElement(LeftOutlined, {
    style: {
      fontSize: '12px',
      color: '#D8D8D8',
      marginRight: '12px'
    }
  }), /*#__PURE__*/React.createElement("span", null, "\u676D\u5DDE\u9065\u671B\u79D1\u6280\u6709\u9650\u516C\u53F8")), (orgPathList === null || orgPathList === void 0 ? void 0 : orgPathList.length) > 1 && /*#__PURE__*/React.createElement("div", {
    className: commonStyles['dept-list']
  }, /*#__PURE__*/React.createElement(Breadcrumb, null, orgPathList.map(function (v, i) {
    if (i === 0) return;
    return /*#__PURE__*/React.createElement(Breadcrumb.Item, {
      className: commonStyles['dept-list-path-item'],
      onClick: function onClick() {
        setOrgPathList(orgPathList.slice(0, i + 1));
      }
    }, get(orgTreeList, v + ".label"));
  }))), !!(currentOrg !== null && currentOrg !== void 0 && (_currentOrg$children3 = currentOrg.children) !== null && _currentOrg$children3 !== void 0 && _currentOrg$children3.length) && /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Row, null, /*#__PURE__*/React.createElement(Col, null, /*#__PURE__*/React.createElement(Checkbox, {
    indeterminate: currentOrg.checkSome,
    onChange: onCheckAllChange,
    checked: currentOrg.checkAll
  }, "\u5168\u9009"))), /*#__PURE__*/React.createElement(Checkbox.Group, {
    style: {
      width: '100%'
    },
    onChange: onChange,
    value: currentOrg.checkedList || []
  }, currentOrg === null || currentOrg === void 0 ? void 0 : (_currentOrg$children4 = currentOrg.children) === null || _currentOrg$children4 === void 0 ? void 0 : _currentOrg$children4.map(function (v, i) {
    return /*#__PURE__*/React.createElement(Row, {
      align: "middle",
      className: commonStyles['item-row']
    }, /*#__PURE__*/React.createElement(Col, {
      span: 20
    }, /*#__PURE__*/React.createElement(Checkbox, {
      value: v.value,
      disabled: v.disabled
    }, v.label)), /*#__PURE__*/React.createElement(Col, {
      span: 4,
      className: commonStyles['item-row-right'],
      onClick: function onClick() {
        if (v.children) {
          setOrgPathList([].concat(orgPathList, [orgPathList[orgPathList.length - 1] + ".children[" + i + "]"]));
        }
      }
    }, v.children && /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("img", {
      src: "https://yw-fed-static.oss-cn-hangzhou.aliyuncs.com/ywDesign/img/org_icon.png"
    }), /*#__PURE__*/React.createElement("span", {
      style: {
        marginLeft: '6px'
      }
    }, "\u4E0B\u7EA7"))));
  })))));
};

YwOrgSelector.defaultProps = {
  title: '请选择部门',
  fieldNames: {
    label: 'orgName',
    value: 'orgId',
    children: 'subOrgList'
  },
  defaultValue: []
};
export default YwOrgSelector;