import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
var _excluded = ["maxItems", "defaultValue", "fieldNames", "fetchOptions", "tagRender", "labelInValue", "children", "onOk", "value", "placeholder", "autoFocus", "showSearch"],
    _excluded2 = ["label", "value"];
import React, { useEffect, useState } from 'react';
import { Modal } from 'antd';
import styles from "./index.module.less";
import YwButton from "../../components/YwButton";
import { DebounceSelect } from "../YwJsonForm/YSearchSelect";
import { obj } from "../../utils/index";

var ModalSelector = function ModalSelector(_ref) {
  var maxItems = _ref.maxItems,
      _ref$defaultValue = _ref.defaultValue,
      defaultValue = _ref$defaultValue === void 0 ? [] : _ref$defaultValue,
      fieldNames = _ref.fieldNames,
      fetchOptions = _ref.fetchOptions,
      tagRender = _ref.tagRender,
      labelInValue = _ref.labelInValue,
      children = _ref.children,
      onOk = _ref.onOk,
      value = _ref.value,
      placeholder = _ref.placeholder,
      autoFocus = _ref.autoFocus,
      showSearch = _ref.showSearch,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  var _useState = useState(false),
      confirmLoading = _useState[0],
      setConfirmLoading = _useState[1];

  var _useState2 = useState(defaultValue),
      selectValue = _useState2[0],
      setSelectValue = _useState2[1];

  useEffect(function () {
    value && setSelectValue(value);
  }, [value]); // useEffect(() => {
  //   props.onChange && props.onChange(selectValue);
  // }, [selectValue]);

  return /*#__PURE__*/React.createElement(Modal, _extends({
    className: styles['modal-selector'],
    maskClosable: false,
    keyboard: false,
    destroyOnClose: true,
    footer: null,
    width: 680
  }, props), /*#__PURE__*/React.createElement("div", {
    className: styles['modal-selector-left']
  }, /*#__PURE__*/React.createElement(DebounceSelect, {
    bordered: false,
    autoFocus: autoFocus,
    defaultValue: defaultValue,
    mode: "multiple",
    showArrow: false,
    style: {
      width: '100%'
    },
    placeholder: placeholder,
    value: selectValue,
    labelInValue: labelInValue,
    showSearch: showSearch,
    onChange: function onChange(nextValue, data) {
      props.onChange(nextValue, data); // setSelectValue(nextValue);
    },
    disabled: props.disabled,
    tagRender: tagRender,
    fieldNames: fieldNames,
    dropdownClassName: styles['dropdown-selector'],
    dropdownRender: function dropdownRender(menu) {
      return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("div", {
        className: styles['dropdown-selector-help']
      }, "\u60A8\u53EF\u80FD\u60F3\u627E"), menu);
    },
    allowClear: true,
    fetchOptions: fetchOptions
  }), /*#__PURE__*/React.createElement("div", {
    className: styles['modal-selector-left-footer']
  }, /*#__PURE__*/React.createElement(YwButton, {
    loading: confirmLoading,
    disabled: (selectValue === null || selectValue === void 0 ? void 0 : selectValue.length) > maxItems,
    btnText: "\u786E\u5B9A (" + (maxItems || (selectValue === null || selectValue === void 0 ? void 0 : selectValue.length)) + "/" + (selectValue === null || selectValue === void 0 ? void 0 : selectValue.length) + ")",
    onClick: function onClick() {
      var value = selectValue.map(function (_ref2) {
        var _ref3;

        var label = _ref2.label,
            value = _ref2.value,
            v = _objectWithoutPropertiesLoose(_ref2, _excluded2);

        return _ref3 = {}, _ref3[fieldNames.label] = label, _ref3[fieldNames.value] = value, _ref3;
      });

      if (obj.isPromise(onOk)) {
        setConfirmLoading(true);
        onOk(value).then(function () {
          props.onCancel();
        })["finally"](function () {
          setConfirmLoading(false);
        });
      } else {
        onOk(value);
      }
    },
    type: "primary"
  }), /*#__PURE__*/React.createElement(YwButton, {
    btnText: "\u53D6 \u6D88",
    onClick: props.onCancel
  }))), /*#__PURE__*/React.createElement("div", {
    className: styles['modal-selector-right']
  }, children));
};

ModalSelector.defaultValue = {
  onOk: function onOk() {},
  defaultValue: [],
  labelInValue: true,
  placeholder: '搜索...',
  onChange: function onChange() {},
  fieldNames: {
    label: 'label',
    value: 'value'
  }
};
export default ModalSelector;