"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireDefault(require("react"));

var _antd = require("@formily/antd");

var _react2 = require("@formily/react");

var _excluded = ["sortable", "layoutProps", "hasAdd", "maxRow", "minRow", "arrayConfig", "name", "editable"];
var SchemaField = (0, _react2.createSchemaField)({
  components: {
    FormItem: _antd.FormItem,
    Editable: _antd.Editable,
    Input: _antd.Input,
    FormLayout: _antd.FormLayout,
    NumberPicker: _antd.NumberPicker,
    Select: _antd.Select,
    RadioGroup: _antd.Radio.Group,
    Space: _antd.Space,
    ArrayItems: _antd.ArrayItems
  }
});

var getArrayItemsSchema = function getArrayItemsSchema(_ref) {
  var _properties;

  var sortable = _ref.sortable,
      name = _ref.name,
      arrayConfig = _ref.arrayConfig,
      editable = _ref.editable,
      arrSchema = _ref.arrSchema,
      maxRow = _ref.maxRow,
      minRow = _ref.minRow;
  var records = {};
  arrayConfig.forEach(function (item, idx) {
    records[item.name] = (0, _extends2["default"])({}, item, {
      "default": item.defaultValue,
      'x-disabled': item.disabled,
      'x-decorator': item.editable ? 'Editable' : 'FormItem',
      'x-component': item.component,
      'x-validator': item.rules,
      'x-decorator-props': (0, _extends2["default"])({}, item.props || {}),
      'x-component-props': (0, _extends2["default"])({}, item.componentProps, {
        required: true
      })
    });
  });
  return {
    type: 'object',
    properties: (_properties = {}, _properties[name] = (0, _extends2["default"])({}, arrSchema, {
      title: '',
      'x-component': 'ArrayItems',
      'x-decorator': 'FormItem',
      'x-read-pretty': arrSchema.readOnly,
      maxItems: maxRow,
      minItems: minRow,
      'x-component-props': (0, _extends2["default"])({}, arrSchema['x-component-props']),
      items: {
        type: 'object',
        // 'x-decorator': 'ArrayItems.Item',
        properties: {
          space: {
            type: 'void',
            'x-component': 'Space',
            'x-component-props': {
              align: 'flex-start'
            },
            properties: (0, _extends2["default"])({}, records, {
              remove: {
                type: 'void',
                title: '删除',
                'x-component': 'ArrayItems.Remove',
                'x-component-props': {
                  style: {
                    color: '#1890ff'
                  } // align: 'flex-start',

                },
                'x-reactions': {
                  dependencies: [name],
                  fulfill: {
                    schema: {
                      'x-visible': '{{$deps[0]?.length > minRow}}' // 任意层次属性都支持表达式

                    }
                  }
                }
              },
              moveUp: {
                type: 'void',
                'x-visible': sortable,
                'x-component': 'ArrayItems.MoveUp'
              },
              moveDown: {
                type: 'void',
                'x-visible': sortable,
                'x-component': 'ArrayItems.MoveDown'
              }
            })
          }
        }
      },
      properties: {
        addition: {
          type: 'void',
          title: '添加',
          'x-component': 'ArrayItems.Addition',
          'x-component-props': {
            align: 'left',
            type: 'link',
            style: {
              width: 80
            }
          },
          'x-reactions': {
            dependencies: [name],
            fulfill: {
              schema: {
                'x-visible': '{{ hasAdd && $deps[0]?.length < maxRow}}'
              }
            }
          }
        }
      }
    }), _properties)
  };
};

var YArrayItems = function YArrayItems(_ref2) {
  var sortable = _ref2.sortable,
      layoutProps = _ref2.layoutProps,
      _ref2$hasAdd = _ref2.hasAdd,
      hasAdd = _ref2$hasAdd === void 0 ? true : _ref2$hasAdd,
      maxRow = _ref2.maxRow,
      _ref2$minRow = _ref2.minRow,
      minRow = _ref2$minRow === void 0 ? 0 : _ref2$minRow,
      _ref2$arrayConfig = _ref2.arrayConfig,
      arrayConfig = _ref2$arrayConfig === void 0 ? [] : _ref2$arrayConfig,
      name = _ref2.name,
      editable = _ref2.editable,
      props = (0, _objectWithoutPropertiesLoose2["default"])(_ref2, _excluded);
  var form = (0, _react2.useParentForm)();
  var arrSchema = (0, _react2.useFieldSchema)();
  var schema = getArrayItemsSchema({
    sortable: sortable,
    arrayConfig: arrayConfig,
    name: name,
    editable: editable,
    arrSchema: arrSchema,
    maxRow: maxRow,
    minRow: minRow
  });
  return /*#__PURE__*/_react["default"].createElement(_react2.FormProvider, {
    form: form
  }, /*#__PURE__*/_react["default"].createElement(SchemaField, {
    schema: schema,
    scope: {
      maxRow: maxRow,
      hasAdd: hasAdd,
      minRow: minRow,
      sortable: sortable
    }
  }));
};

var _default = (0, _react2.observer)(YArrayItems);

exports["default"] = _default;