"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var React = _interopRequireWildcard(require("react"));

var _antd = require("@formily/antd");

var _YDatePicker = require("./YDatePicker");

var _react2 = require("@formily/react");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var RadioGroup = _antd.Radio.Group;
var CheckboxGroup = _antd.Checkbox.Group;
var TextArea = _antd.Input.TextArea;
var SchemaField = (0, _react2.createSchemaField)({
  components: {
    FormItem: _antd.FormItem,
    Input: _antd.Input,
    Select: _antd.Select,
    RadioGroup: RadioGroup,
    TextArea: TextArea,
    Switch: _antd.Switch,
    CheckboxGroup: CheckboxGroup,
    NumberPicker: _antd.NumberPicker,
    Cascader: _antd.Cascader,
    WeekRangePicker: _YDatePicker.WeekRangePicker,
    DateRangePicker: _YDatePicker.DateRangePicker,
    MonthRangePicker: _YDatePicker.MonthRangePicker,
    DateTimeRangePicker: _YDatePicker.DateTimeRangePicker,
    MonthPicker: _YDatePicker.MonthPicker,
    WeekPicker: _YDatePicker.WeekPicker,
    DatePicker: _YDatePicker.DatePicker,
    DateTimePicker: _YDatePicker.DateTimePicker
  }
});

var YInputGroup = function YInputGroup(props) {
  var field = (0, _react2.useField)();
  var form = (0, _react2.useParentForm)();
  var schema = (0, _react2.useFieldSchema)();
  return /*#__PURE__*/React.createElement(_react2.FormProvider, {
    form: form
  }, field.editable ? /*#__PURE__*/React.createElement(_antd.Input.Group, {
    compact: true
  }, /*#__PURE__*/React.createElement(_antd.Select, {
    defaultValue: field.initialValue,
    disabled: field.disabled,
    options: field.dataSource,
    onChange: function onChange(v) {
      field.setValue(v);
    }
  }), /*#__PURE__*/React.createElement(SchemaField, {
    schema: schema
  })) : /*#__PURE__*/React.createElement(SchemaField, {
    schema: schema
  }));
};

var _default = YInputGroup;
exports["default"] = _default;