import React from 'react';
import type { SelectProps } from 'antd/es/select';
export interface DebounceSelectProps<ValueType = any> extends Omit<SelectProps<ValueType | ValueType[]>, 'options' | 'children'> {
    fetchOptions: (search: string) => Promise<ValueType[]>;
    debounceTimeout?: number;
    fieldNames?: {
        label: string;
        value: string;
    };
}
export declare function DebounceSelect<ValueType extends {
    key?: string;
    label: React.ReactNode;
    value: string | number;
} = any>({ fetchOptions, debounceTimeout, ...props }: DebounceSelectProps<ValueType>): JSX.Element;
declare const YSearchSelect: (props: any) => JSX.Element;
export default YSearchSelect;
