"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireWildcard(require("react"));

var _indexModule = _interopRequireDefault(require("./index.module.less"));

var _indexModule2 = _interopRequireDefault(require("../common/index.module.less"));

var _lodash = require("lodash");

var _antd = require("antd");

var _icons = require("@ant-design/icons");

var _modalSelector = _interopRequireDefault(require("../common/modalSelector"));

var _index = require("../../utils/index");

var _excluded = ["getDataSource", "visible"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var YwOrgSelector = function YwOrgSelector(_ref) {
  var _currentOrg$children3, _currentOrg$children4;

  var getDataSource = _ref.getDataSource,
      visible = _ref.visible,
      props = (0, _objectWithoutPropertiesLoose2["default"])(_ref, _excluded);

  // 部门树结构
  var _useState = (0, _react.useState)([]),
      orgTreeList = _useState[0],
      setOrgTreeList = _useState[1];

  var _useState2 = (0, _react.useState)([]),
      orgPathList = _useState2[0],
      setOrgPathList = _useState2[1];

  var defaultValue = (0, _react.useMemo)(function () {
    return (0, _index.formatOptionsList)(props.defaultValue, props.fieldNames);
  }, [props.defaultValue, props.fieldNames]); // select组件回显部门数据
  // const [selectValue, setSelectValue] = useState(defaultValue);
  // 当前节点

  var currentOrg = (0, _react.useMemo)(function () {
    return (0, _lodash.get)(orgTreeList, (0, _lodash.last)(orgPathList));
  }, [orgPathList, orgTreeList]); // 当前path

  var orgPath = (0, _react.useMemo)(function () {
    return (0, _lodash.last)(orgPathList);
  }, [orgPathList]);

  var onChange = function onChange(list, data) {
    var _currentOrg$children;

    var _currentOrg = (0, _extends2["default"])({}, currentOrg, {
      checkedList: list,
      checkedData: currentOrg === null || currentOrg === void 0 ? void 0 : currentOrg.children.filter(function (v) {
        return list.includes(v.value);
      }),
      checkAll: list.length === (currentOrg === null || currentOrg === void 0 ? void 0 : currentOrg.children.length),
      checkSome: !!list.length && list.length < (currentOrg === null || currentOrg === void 0 ? void 0 : (_currentOrg$children = currentOrg.children) === null || _currentOrg$children === void 0 ? void 0 : _currentOrg$children.length)
    });

    var _orgTreeList = (0, _lodash.set)(orgTreeList, orgPath, _currentOrg);

    setOrgTreeList([].concat(_orgTreeList));
  };

  var onCheckAllChange = function onCheckAllChange(e) {
    var _currentOrg$children2;

    var _currentOrg = (0, _extends2["default"])({}, currentOrg, {
      checkedList: e.target.checked ? currentOrg === null || currentOrg === void 0 ? void 0 : (_currentOrg$children2 = currentOrg.children) === null || _currentOrg$children2 === void 0 ? void 0 : _currentOrg$children2.map(function (v) {
        return v.value;
      }) : [],
      checkedData: e.target.checked ? currentOrg === null || currentOrg === void 0 ? void 0 : currentOrg.children : [],
      checkAll: e.target.checked,
      checkSome: false
    });

    var _orgTreeList = (0, _lodash.set)(orgTreeList, orgPath, _currentOrg);

    setOrgTreeList([].concat(_orgTreeList));
  };

  (0, _react.useEffect)(function () {}, [orgTreeList]);
  var selectValue = (0, _react.useMemo)(function () {
    var _selectValue = [];

    var getItemCheckedData = function getItemCheckedData(dataList) {
      dataList.forEach(function (data) {
        if (data.children) {
          getItemCheckedData(data.children);
        }

        _selectValue.push.apply(_selectValue, data.checkedData || []);
      });
    };

    getItemCheckedData(orgTreeList);
    return _selectValue;
  }, [orgTreeList]);
  (0, _react.useEffect)(function () {
    if (visible) {
      getDataSource().then(function (data) {
        var res = (0, _index.formatOptionsList)(data, props.fieldNames);
        var _orgTreeList = [{
          value: '0',
          label: '杭州遥望科技有限公司',
          children: res
        }];
        setOrgPathList(['[0]']);

        if (defaultValue !== null && defaultValue !== void 0 && defaultValue.length) {
          setOrgCheckData(defaultValue, _orgTreeList);
        } else {
          setOrgTreeList(_orgTreeList);
        }
      });
    }
  }, [visible]);

  var setOrgCheckData = function setOrgCheckData(nextValue, _orgTreeList) {
    var newOrgTreeList = _orgTreeList || [].concat(orgTreeList);

    var setItemCheckedData = function setItemCheckedData(dataList) {
      dataList.forEach(function (data) {
        var _checkedData = _orgTreeList ? (0, _lodash.intersectionBy)(data.children || [], nextValue, 'value') : (0, _lodash.intersectionBy)(data.checkedData || [], nextValue, 'value') || [];

        data.checkedData = _checkedData;
        data.checkedList = _checkedData.map(function (v) {
          return v.value;
        });

        if (data.children) {
          var _data$children, _data$children2;

          data.checkAll = ((_data$children = data.children) === null || _data$children === void 0 ? void 0 : _data$children.length) === (_checkedData === null || _checkedData === void 0 ? void 0 : _checkedData.length);
          data.checkSome = ((_data$children2 = data.children) === null || _data$children2 === void 0 ? void 0 : _data$children2.length) > (_checkedData === null || _checkedData === void 0 ? void 0 : _checkedData.length) && !!_checkedData.length;
          setItemCheckedData(data.children);
        }
      });
    };

    setItemCheckedData(newOrgTreeList);
    setOrgTreeList([].concat(newOrgTreeList));
  };

  return /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule["default"]['yw-org-selector']
  }, /*#__PURE__*/_react["default"].createElement(_modalSelector["default"], (0, _extends2["default"])({}, props, {
    visible: visible,
    labelInValue: true,
    autoFocus: false,
    showSearch: false,
    value: selectValue,
    onChange: setOrgCheckData
  }), /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule2["default"]['title'],
    onClick: function onClick() {
      setOrgPathList(['[0]']);
    }
  }, /*#__PURE__*/_react["default"].createElement(_icons.LeftOutlined, {
    style: {
      fontSize: '12px',
      color: '#D8D8D8',
      marginRight: '12px'
    }
  }), /*#__PURE__*/_react["default"].createElement("span", null, "\u676D\u5DDE\u9065\u671B\u79D1\u6280\u6709\u9650\u516C\u53F8")), (orgPathList === null || orgPathList === void 0 ? void 0 : orgPathList.length) > 1 && /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule2["default"]['dept-list']
  }, /*#__PURE__*/_react["default"].createElement(_antd.Breadcrumb, null, orgPathList.map(function (v, i) {
    if (i === 0) return;
    return /*#__PURE__*/_react["default"].createElement(_antd.Breadcrumb.Item, {
      className: _indexModule2["default"]['dept-list-path-item'],
      onClick: function onClick() {
        setOrgPathList(orgPathList.slice(0, i + 1));
      }
    }, (0, _lodash.get)(orgTreeList, v + ".label"));
  }))), !!(currentOrg !== null && currentOrg !== void 0 && (_currentOrg$children3 = currentOrg.children) !== null && _currentOrg$children3 !== void 0 && _currentOrg$children3.length) && /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_antd.Row, null, /*#__PURE__*/_react["default"].createElement(_antd.Col, null, /*#__PURE__*/_react["default"].createElement(_antd.Checkbox, {
    indeterminate: currentOrg.checkSome,
    onChange: onCheckAllChange,
    checked: currentOrg.checkAll
  }, "\u5168\u9009"))), /*#__PURE__*/_react["default"].createElement(_antd.Checkbox.Group, {
    style: {
      width: '100%'
    },
    onChange: onChange,
    value: currentOrg.checkedList || []
  }, currentOrg === null || currentOrg === void 0 ? void 0 : (_currentOrg$children4 = currentOrg.children) === null || _currentOrg$children4 === void 0 ? void 0 : _currentOrg$children4.map(function (v, i) {
    return /*#__PURE__*/_react["default"].createElement(_antd.Row, {
      align: "middle",
      className: _indexModule2["default"]['item-row']
    }, /*#__PURE__*/_react["default"].createElement(_antd.Col, {
      span: 20
    }, /*#__PURE__*/_react["default"].createElement(_antd.Checkbox, {
      value: v.value,
      disabled: v.disabled
    }, v.label)), /*#__PURE__*/_react["default"].createElement(_antd.Col, {
      span: 4,
      className: _indexModule2["default"]['item-row-right'],
      onClick: function onClick() {
        if (v.children) {
          setOrgPathList([].concat(orgPathList, [orgPathList[orgPathList.length - 1] + ".children[" + i + "]"]));
        }
      }
    }, v.children && /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("img", {
      src: "https://yw-fed-static.oss-cn-hangzhou.aliyuncs.com/ywDesign/img/org_icon.png"
    }), /*#__PURE__*/_react["default"].createElement("span", {
      style: {
        marginLeft: '6px'
      }
    }, "\u4E0B\u7EA7"))));
  })))));
};

YwOrgSelector.defaultProps = {
  title: '请选择部门',
  fieldNames: {
    label: 'orgName',
    value: 'orgId',
    children: 'subOrgList'
  },
  defaultValue: []
};
var _default = YwOrgSelector;
exports["default"] = _default;